/* Test_Project_23_0.96-OLED.ino. Updated: 2023-02-22.
 *  Modified for the M0 2Box project (Adafruit QT PY in the small Hammond project box 1591TCL).
 *  2021-03-05 prefontDon@gmail.com
 *  "Soft RTC" Reference: https://learn.adafruit.com/adafruit-adalogger-featherwing/adafruit2-rtc-with-arduino
 *  u8x8 library: https://www.arduinolibraries.info/libraries/u8g2 and https://github.com/olikraus/u8g2/wiki/fntlist8x8
 *  Use "millsTS()" to troubleshoot your system.
 *  Use "millsPlot" and Tools/Serial Plotter to plot just barometric pressure. Start it after the sketch downloads.
*/ 
//#include <ArduinoLowPower.h> // Available if you wish to use it instead of "delay()".
//LowPower.deepSleep(1000);    // LowPower.deepSleep(milliseconds);

int redLED = A1;               // Pin A1 is output to the red LED.
//int greenLED = Ax;           // Not used in this configuration. Set the pin number for your microcontroller.
//int blueLED = Ax;
//const uint8_t numLED = 3;            // Number of LEDs is 3.
//const int ledArray[3] = {A1,Ax,Ax};  // Array of LEDs (red, green, blue). Index starts with logical 0.
//uint8_t ledIndex;                    // Index of ledArray.

int PIRpin = A6;               // Pin A2 input from PIR (passive infrared) motion sensor.
int pirState = LOW;            // We'll start with a LOW state: no motion was detected.

//int LDR = Ax;                // Pin Ax is output from LDR device.

/* Piezo buzzer */
  int piezoPin = A0;             // Pin A0 is output to the piezo buzzer.
  int numTones = 3;                          
  int Tones[] = {392, 415, 440}; // The melody is comprised of the last 3 tones. Total of 10 tones listed below.
//int Tones[] = {261, 277, 294, 311, 330, 349, 370, 392, 415, 440};
//             mid C   C#   D    D#   E    F    F#   G    G#   A

/* OPTIONAL: 4-character 7-segment LED matrix. 
 *  #include "Adafruit_LEDBackpack.h"                // For backpacks with 3 Address Select pins: 0x70 thru 0x77.
 *  Adafruit_7segment matrix7 = Adafruit_7segment(); // Quad 7-segment LED module with I2C backpack.
*/

#include <U8x8lib.h>           // RAM-economical text-only OLED display driver! Ideal for ATmega328 microcontrollers.
U8X8_SSD1306_128X64_NONAME_HW_I2C u8x8(/* reset=*/ U8X8_PIN_NONE);  // 4-pin I2C 1.3" 128x64 OLED with no Reset.
//U8X8_SH1106_128X64_NONAME_HW_I2C u8x8(/* reset=*/ U8X8_PIN_NONE);   // 4-pin I2C 1.3" 128x64 OLED with no Reset.

#include <Wire.h>                     // For I2C (SCL, SDA pins).                    
#include <Adafruit_Sensor.h>          // For all Adafruit sensors. 
#include <Adafruit_BME280.h>          // BME280 sensor: temperature, humidity, barometric pressure.
Adafruit_BME280 bme;                  // Uses I2C. Object name is "bme".
#define SEALEVELPRESSURE_HPA (1000.00)// Google "barometric pressure YourCity" to get the current value for determining altitude.
                                      // Altitude is not very accurate so I don't use it.                                         
#include <RTClib.h>                   // "Soft" Real time clock library used with Cortex M0/M4, etc.
RTC_Millis rtc;                       // Taken from "softrtc.ino" example in RTClib library. Object name is "rtc".
//RTC_DS1307 rtc;                     // We use LiPo backed up hard clock in this project. 
//RTC_PCF8523 rtc;                    // We switched from the DS1307 to the PCF8523 due to its better accuracy.
                                      // Comment-out the "RTC_xxxxxx rtc" line and uncomment the "RTC_Millis rtc" line to run soft clock.
                                      // char daysOfTheWeek[7][12] = {"Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"};                                                   
//Include the SD library:
#include <SPI.h>                    // Hardware SPI library: D10:SS, MOSI, MISO , SCK.
#include <SD.h>                     // SD library.
File statsFile;                     // SD object name to write weather stats to; filename will be "THBP.txt".

long oledOnTime = 8000;             // Milliseconds of OLED display on-time.
                                    // Note: PIR built-in "on" time value is 7 to 8s so make sure oledOnTime is a larger value.
long SdWriteTime = 60000;           // Milliseconds (60s) between stats writes to microSD card.
unsigned long currentMillis = 0;    // millis = mS since reboot. This is a copy of that value for this point in time.
unsigned long previousMillis = 0;   // mS elapsed since last "currentMillis = millis()".  
unsigned long oledMillis = 0;       // OLED on-time in ms.
unsigned long totalOledMillis = 0;  // OledMillis time since last reset.    
unsigned long totalSdMillis = 0;    // SD time since last write. 
//unsigned long sdMillis = 0;  

/* Trending Parameters */
const int arrSiz = 10;            // Array Size.
float arrTc[10];                  // Arrays for stats: Temp C, Humidity %, BP kPa.
float arrH[10];                   
float arrBP[10];                  
//
float sumTc = 0; float avgTc = 0; 
int avgDltaTc = 0;                // Average change in Tc.
int sumArrDltaTc = 0;             // Sum of average Tc changes.
//
float sumH = 0; float avgH = 0;
int avgDltaH = 0;                 // Average change in H.
int sumArrDltaH = 0;              // Sum of average H changes.
//
float sumBP = 0; float avgBP = 0;
int avgDltaBP = 0;                // Average change in BP.
int sumArrDltaBP = 0;             // Sum of average BP changes.
//
bool TcHigher = false; bool TcLower = false;
bool HHigher = false; bool HLower = false;
bool BPHigher = false; bool BPLower = false;
//
int Ythbp = 0;                    // Y-axis value for outOledBig procedure.

//int arrDltaTc[10] = {3};          // Array of Tc changes.
//int k = 0;
/*--------------------------------------------------*/
/*---------------------- SETUP ---------------------*/
/*--------------------------------------------------*/
void setup(void) {
  Serial.begin(57600);       // Pass/fail diags can be seen in Serial Monitor. 
  
  pinMode(redLED, OUTPUT);   // Set redLED pin as output to LED.
//pinMode(greenLED, OUTPUT);
//pinMode(blueLED, OUTPUT);
/*
  for (ledIndex = 0; ledIndex <3; ledIndex++) {
    pinMode(ledArray[ledIndex], OUTPUT);              
    digitalWrite(ledArray[ledIndex], HIGH);   }  // Setting common anode RGB LED pins HIGH turns them off.
*/  
//allLEDsOff(); 
  pinMode(PIRpin,INPUT);          // PULLUP and PULLDOWN are not supported on AVR ATmega, only Cortex Mx microcontrollers.
//pinMode(PIRpin,INPUT_PULLDOWN); // Large PIR outputs logical HIGH for about 7 - 8 seconds to indicate motion was sensed.
                                  // Small PIR outputs a logical HIGH for about 3 - 4s. 
                                  // With INPUT_PULLUP, the PIR's LOW is biased at +1v and its HIGH is 3.3v.
                                  // With INPUT_PULLDOWN, the PIR's LOW is 0v and its HIGH limit is +2v.                      
  u8x8.begin();           // Start OLED: initDisplay, clearDisplay, setPowerSave.
  u8x8.setPowerSave(0);   // Disable OLED power save function. https://github.com/olikraus/u8g2/wiki/u8x8reference#setpowersave
  u8x8.clearDisplay();    // Clears entire display, not just one line.
  
  bme.begin();            // Start BME280 sensor.                
/*
  if (! rtc.begin()) {
    Serial.println("Couldn't find RTC");
    Serial.flush();
    //abort();         
    }
  if (! rtc.initialized() || rtc.lostPower())                      {
    Serial.println("RTC is NOT initialized, let's set the time!");
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));                }
  rtc.start();  
*/
  rtc.begin(DateTime(F(__DATE__), F(__TIME__)));  // Sets the RTC to the date & time this sketch was compiled.
  // Set the RTC with an explicit date & time. For February 22, 2023 at 12:30pm you would call: rtc.begin(DateTime(2023, 02, 22, 12, 30, 0)); 
  
  delay(500);            // Delay needed or SD statements may not display in Serial Monitor.
  Serial.print(F("Initializing SD card..."));
  pinMode(A3, OUTPUT);   // Note that even if it's not used as the CS pin, the hardware SPI SS pin (usually D10, A3 in this instance)... 
                         // ...must be left as an output or the SPI SD library functions will not work. 
  if (!SD.begin(A3)) {
  Serial.println(F(" \nSD initialization failed!\n")); return;  }
  Serial.println(F("\nSD initialization done.\n"));

  fillTc();  fillH();  fillBP();  // Quickly backfill all three stats arrays with the current stats.
  
  Serial.println("\n***** Stats will only display on Serial Monitor and OLED when there is PIR activity *****");
  
/* Quad 7-segment LED module with I2C backpack. Set the pin mode for the LEDs as Output. 
 * Common anode LEDs light with a LOW. Set starting state to HIGH.
  matrix7.begin(0x70);     // I2C address passed is 0x70.
  Seg7LedsOff();           // Prevent random quad 7-segment display during reboot.
*/  
}
/*--------------------------------------------------*/
/*---------------------- Loop ----------------------*/
/*--------------------------------------------------*/
void loop(void) {  
  monSD();                  // Monitor SD. Write stats to microSD card every SdWriteTime(60000ms, one minute).
  monPIR();                 // Monitor PIR. Display stats on OLED for oledOnTime (8000ms) whenever motion is detected.
  currentMillis = millis(); // Update the current time after each loop pass. Used to determine if either counter above expired.
//millsPlot();              // Use "millsPlot" and Serial Plotter to plot just barometric pressure. Start it after the sketch downloads.
//millsTS();                // Use "millsTS" to troubleshoot your system.
}  
//******************************************************************************
void monSD(void) {  /* microSD Monitoring Code: periodically write the WI stats to a microSD card. */ 
  totalSdMillis = totalSdMillis + (currentMillis - previousMillis);      
  if(totalSdMillis >=  SdWriteTime) {   // Write stats to SD and play tone if time between SD writes exceeds threshold.
    totalSdMillis = 0;  
    outSD();
    playTone_1();                   
  }
}
//******************************************************************************
void monPIR(void) {  /* PIR Monitoring Code: OLED displays only when motion is detected or there is a change in stats. */    
  totalOledMillis = totalOledMillis + (currentMillis - previousMillis); 
  if((digitalRead(PIRpin) == LOW)  && (totalOledMillis < oledOnTime))  { /* NO movement. */
    pirState = LOW;  
    offLED();               // Turn off the LED.
  } else 
  if((digitalRead(PIRpin) == LOW) && (totalOledMillis >= oledOnTime))  { /* NO movement. */
    pirState = LOW; 
    totalOledMillis = 0; 
    u8x8.clearDisplay();    // Clear the OLED display.
    offLED();               // Turn off the LED.
    //Seg7LedsOff();        // Turn off the quad 7-segment LED display.
  } else
  if((digitalRead(PIRpin) == HIGH) && (totalOledMillis < oledOnTime))  { /* Movement! */
    pirState = HIGH; 
    onLED();                // Turn on the LED(s).  
//** Display and trending is done here (not in the main loop) to limit display usage.    
    outOLEDbig();           // Display just T, F and BP in large font for a short period of time.
    //Seg7LedsOn(); 
    monTc();                // Monitor changes in Temp Celsius. Arrows indicate change of direction - up or down.
    monH();                 // Monitor changes in Humidity %. Arrows indicate change of direction - up or down.
    monBP();                // Monitor changes in BP kPa. Arrows indicate change of direction - up or down.
//**
    u8x8.clearDisplay();    // Clear the OLED display.
    outOLED();              // Display the OLED info for a longer period of time.
    u8x8.clearDisplay();    // Clear the OLED display.
  } else 
  if((digitalRead(PIRpin) == HIGH)  && (totalOledMillis >= oledOnTime))  { /* Movement! */
    pirState = HIGH; 
    totalOledMillis = 0;   
    u8x8.clearDisplay();    // Clear the OLED display to stop displaying the stats.
    offLED();               // Turn off the LED(s).
  }
  previousMillis = currentMillis; // Remember the new current time.
}
//******************************************************************************
void outOLEDbig(void) {          // Displays T, H and BP in larger font.
  DateTime now = rtc.now();      // Must be in each function's scope.
  u8x8.clearDisplay();  
//
  Ythbp = 0;                         // Y-column position for T, H and BP.
  float Tc = bme.readTemperature();  // Temp in C.  
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f);                // https://github.com/olikraus/u8g2/wiki/fntlist8x8
  u8x8.drawString(3,Ythbp,"T:");     // T:    
  u8x8.setCursor(8,Ythbp);           // This is where the trending arrow will be inserted later.  
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f);                                 
  u8x8.print(Tc,0);                  // T: xx
  u8x8.drawString(13,Ythbp,"c");     // T: xxc   
  delay(10);
//
  Ythbp = 3;                          // Y-column position for T, H and BP.
  float H = bme.readHumidity();       // Humidity %.
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
  u8x8.drawString(3,Ythbp,"H: ");     // H:          
  u8x8.setCursor(8,Ythbp);            // This is where the trending arrow will be inserted later.   
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); // No "%" symbol.           
  u8x8.print(H,0);                    // H: xx
  u8x8.setFont(u8x8_font_px437wyse700b_2x2_f); // Supports "%" symbol. https://github.com/olikraus/u8g2/wiki/fntlist8x8
  u8x8.drawString(13,Ythbp,"%");      // H: xx%        
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
  delay(10);
//
  Ythbp = 6;                                  // Y-column position for T, H and BP.      
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000). 
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
  u8x8.drawString(1,Ythbp,"BP: ");    // BP:     
  u8x8.setCursor(8,Ythbp);            // This is where the trending arrow will be inserted later.
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
  u8x8.print(BP,0);                   // BP: xxx
  u8x8.drawString(14,Ythbp,"k");      // BP: xxx k // kPa: kiloPascals.    
  delay(2500);                         // 2.5s: time to read the large print.
}
//******************************************************************************
void monTc() {  /* Monitor temp. */   // "arr" = array, "Dlta" = Delta or change, "Tc" = temperature in degrees celsius.  
  float Tc = bme.readTemperature();   // Array Tc (arrTc) was initially populated with current values.
  for (int ii = (arrSiz - 1); ii > 0; ii--) {  
    arrTc[ii] = arrTc[ii - 1];  }     // Starting from the right (array index [9]), shift the entire array to the right ONCE. 
  arrTc[0] = Tc;                      // The current Tc is inserted into the left-most array position [0] that was opened up.
  Serial.println(" ");
  sumTc = 0;                          // Reset the sum of the Tc values in the array.
// 
  for (int j=0; j < arrSiz; j++) {    // Once the entire array (arrTc) is filled, display the entire numbered array.
    Serial.print(j); Serial.print(": "); // Number the array elements.
    Serial.print(arrTc[j],1);            // Display each array element.
    Serial.print("  ");                  // Separate each numbered element.
    sumTc += arrTc[j];           }    // Add up all of the Tc values in the array... 
    avgTc = (sumTc / arrSiz);         // ...then divide by the array size to get the average Tc value.
  Serial.print("Average Tc: ");       // Display the average temperature in degrees C.
  Serial.println(avgTc,1);            // Single digit precision.
//  
  float deltaTcFl = (arrTc[0] - avgTc);  // Current Tc (arrTc[0]) is compared to average Tc (avgTc) to yield deltaTcFl.
  int deltaTc = (int)deltaTcFl;          // Cast the float (deltaTcFl) to an integer (deltaTc) to ease calculations.
  Serial.print(" deltaTcFl: "); Serial.print(deltaTcFl);  // Print the change in Tc as a floating decimal number.
  Serial.print("\tdeltaTc: ");  Serial.print(deltaTc);    // Print the change in Tc as an integer.  
//   
  Ythbp = 0;                          // Set Y position to the first (zero) row.
  if (deltaTcFl > 0.5)    {           // Report if current Tc is higher or lower than the array average or if it's the same. 
    Serial.println("\tTc = higher "); TcHigher = true; TcLower = false; upArrow();
    } else 
  if (deltaTcFl < -0.5)    {
    Serial.println("\tTc = lower");   TcLower = true; TcHigher = false; downArrow();    
    } else
    Serial.println("\tTC = same. ");  TcHigher = false; TcLower = false; noArrow(); /*(deltaTc = 0);*/   
}
//******************************************************************************+ 
void monH() {  /* Monitor humidity */ // "arr" = array, "Dlta" = Delta or change, "H" = humidity percentage %.         
  float H = bme.readHumidity();       // Array H (arrH) was initially populated with current values.                                     
  for (int m = (arrSiz - 1); m > 0; m--) {  // Starting from the right ([9]), shift each array variable to the right ONCE.
    arrH[m] = arrH[m - 1];    }        // Continue to do this every time interval until the entire array has been replaced with the current H.
  arrH[0] = H;                         // The current H is inserted into the left-most array position [0] that was opened up.
  Serial.println(" "); 
  sumH = 0;                           // Reset the sum of the H values in the array.
//
  for (int n=0; n < arrSiz; n++) {    // Once the entire array (arrH) is filled, display the array.
    Serial.print(n); Serial.print(": ");
    Serial.print(arrH[n],1);         
    Serial.print("  "); 
    sumH += arrH[n];             }    // Add up all of the H values in the array... 
    avgH = (sumH / arrSiz);           // ...then divide by the array size to get the average H value.
  Serial.print("Average H: ");        // Display the average H %.
  Serial.println(avgH,1);        
//  
  float deltaHFl = (arrH[0] - avgH);  // Current H (arrH[0]) is compared to average H (avgH) to yield deltaHFl.
  int deltaH = (int)deltaHFl;         // Cast the float (deltaHFl) to an integer (deltaH) to ease calculations.
  Serial.print(" deltaHFl: "); Serial.print(deltaHFl);  // Print the change in H as a float.
  Serial.print("\t\tdeltaH: ");  Serial.print(deltaH);    // Print the change in H as an integer.  
// 
  Ythbp = 3;                          // Set Y position to the 4th row (0=1st row, 3=4th, 6=7th).
  if (deltaH > 0.5)  {                // Report if current H is higher, lower or the same. 
    Serial.println("\tH = higher "); HHigher = true; HLower = false; upArrow();
    } else 
  if (deltaH < -0.5) {   
    Serial.println("\tH = lower"); HLower = true; HHigher = false; downArrow();   
    } else Serial.println("\tH = same. ");  HHigher = false; HLower = false; noArrow(); /*(deltaH = 0);*/   
}
//****************************************************************************** 
void monBP() {  /* Monitor Barometric Pressure */ // "arr" = array, "Dlta" = Delta or change,  Barometric Pressure in kPa.         
  float BP = bme.readPressure() / 1000.0F;  // Array BPH (arrBP) was initially populated with current values.
  for (int p = (arrSiz - 1); p > 0; p--) {  // Starting from the right ([9]), shift each array variable to the right once.
    arrBP[p] = arrBP[p-1];         }  // Continue to do this every time interval until the entire array has been replaced with the current BP.
  arrBP[0] = BP;                      // The current BP is inserted into the left-most array position [0] that was opened up.
  Serial.println(" "); 
  sumBP = 0;                          // Reset the sum of the BP values in the array.
//   
  for (int q=0; q < arrSiz; q++) {    // Once the entire array (arrBP) is filled, display the array.
    Serial.print(q); Serial.print(": "); 
    Serial.print(arrBP[q],1);         
    Serial.print("  "); 
    sumBP += arrBP[q];           }    // Add up all of the BP values in the array... 
    avgBP = (sumBP / arrSiz);         // ...then divide by the array size to get the average BP value.
  Serial.print("Average BP: ");       // Display the average BP kPa.
  Serial.println(avgBP,1);        
//   
  float deltaBPFL = (arrBP[0] - avgBP); // Current BP (arrBP[0]) is compared to average BP (avgBP) to yield deltaBPFL.
  float deltaBP = deltaBPFL;            // Removed the cast-to-int but just for BP, not Tc nor H.
//int deltaBP = (int)deltaBPFL;         // Cast the float (deltaBPFL) to an integer (deltaBP) to ease calculations.
  Serial.print(" deltaBPFL: "); Serial.print(deltaBPFL);  // Print the change in BP as a float.
  Serial.print("\tdeltaBP: ");  Serial.print(deltaBP);    // Print the change in BP as an integer.  
// 
  Ythbp = 6;                          // Set Y position to the 4th row (0=1st, 3=4th, 6=7th).
  if (deltaBP > 0.05)    {            // Report if current BP is higher, lower or the same. 
    Serial.println("\tBP = higher "); BPHigher = true; BPLower = false; upArrow();
    } else 
    if (deltaBP < (-0.5))    {
      Serial.println("\tBP = lower");   BPLower = true;  BPHigher = false; downArrow();   
      } else 
        Serial.println("\tBP = same. "); BPLower = false; BPHigher = false; noArrow(); /* (deltaBP = 0);*/        
  }
//****************************************************************************** 
void downArrow() {   /* Down arrow used by the Trending routine */
  u8x8.setFont(u8x8_font_open_iconic_arrow_2x2);  // https://github.com/olikraus/u8g2/wiki/fntlist8x8 Choose U8x8 Fonts then search for "iconic_arrow".
  u8x8.drawString(6,Ythbp,"\x44");                // Down arrow. https://github.com/olikraus/u8g2/wiki/u8x8reference#drawglyph
  delay(500);
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); // https://github.com/olikraus/u8g2/wiki/fntlist8x8 
}                                                           // In right panel choose U8x8 Fonts, then search for "scumm".  
//******************************************************************************
void upArrow() {     /* Up arrow used by the Trending routine */
  u8x8.setFont(u8x8_font_open_iconic_arrow_2x2);
  u8x8.drawString(6,Ythbp,"\x47");                          // Up arrow.
  delay(500);
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
}  
//******************************************************************************
void noArrow() {    /* Space character is used */
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
  u8x8.drawString(6,Ythbp,"\x20");                          // Space character.
  delay(500);
}
//****************************************************************************** 
//****************************************************************************** 
void outOLED() {
  DateTime now = rtc.now();                  // Must be in each function's scope.
  u8x8.clearDisplay();
  u8x8.setFont(u8x8_font_chroma48medium8_r); // Font chosen.
  u8x8.drawString(0,0," WEATHER INSIDE");    // Display the program title. 
  u8x8.drawString(0,2,"T: ");                // Display Temperature in C (default) and F.
  u8x8.setCursor(4,2);
  float Tc = bme.readTemperature();          // Temp in C.
  u8x8.print(Tc,0); 
  u8x8.drawString(6,2,"c");                               
  u8x8.setCursor(8,2);
  float Tf = ((Tc * 1.8) + 32);     // Temp in F.
  u8x8.print(Tf,0);     
  u8x8.drawString(10,2,"f");  
  u8x8.drawString(0,3,"H: ");       // Display Humidity in %.
  u8x8.setCursor(4,3);
  float H = bme.readHumidity();     // Humidity %.
  u8x8.print(H,0);
  u8x8.drawString(6,3,"%");
  u8x8.drawString(0,4,"DP:");       // Display Dew Point in C and F.
  u8x8.setCursor(4,4);
  float TDPc = ((100 - H) / 5);     // Dew Point temperature in C.
  u8x8.print(TDPc,0);
  u8x8.drawString(6,4,"c"); 
  u8x8.setCursor(8,4);  
  float TDPf = ((TDPc * 1.8) + 32); // Dew Point temperature in F.
  u8x8.print(TDPf,0);
  u8x8.drawString(10,4,"f");  
  u8x8.drawString(0,5,"HX: ");      // Display Humidex in C and F using formula at bottom.
  u8x8.setCursor(4,5);
  float TDPk = TDPc + 273.15;       // Dew Point temperature in K. 
  float HXc = Tc + (0.5555 * (pow(6.11,(5417.7530 * ((1/273.16) - (1/TDPk))) - 10)));  // Calculate Humidex in C based on Dew Point and Humidity.
  u8x8.print(HXc,0);
  u8x8.drawString(6,5,"c");  
  u8x8.setCursor(8,5);  
  float HXf = ((HXc * 1.8) + 32);   // Humidex in F.
  u8x8.print(HXf,0);      
  u8x8.drawString(10,5,"f"); 
  u8x8.drawString(0,6,"BP:");       // Display Barometric Pressure in kilo Pascals (kPa)
  u8x8.setCursor(4,6); 
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  u8x8.print(BP,1);
  u8x8.drawString(10,6,"kPa");  
/*  
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  u8x8.print(BPmm,1);
  u8x8.drawString(10,6,"mmHg");
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  u8x8.print(BPin,1);
  u8x8.drawString(10,6,"inHg"); 
*/
// Date & Time:
  u8x8.setCursor(0,7);              //// YYYY/MM/DD HH:MM
  u8x8.print(now.year(),DEC);
  u8x8.drawString(4,7,"/");         //// (2,7,"/")
    
  u8x8.setCursor(5,7);              //// (3,7)
  if (now.month() < 10) {u8x8.print("0");} // Ensure value is two digits for formatting purposes.
  u8x8.print(now.month(),DEC);
  u8x8.drawString(7,7,"/");         //// (5,7,"/")
  
  u8x8.setCursor(8,7);              //// (6,7)
  if (now.day() < 10)    {u8x8.print("0");} // Ensure value is two digits for formatting purposes.
  u8x8.print(now.day(), DEC);    
  u8x8.drawString(10,7," ");        //// (8,7," ")
  
  u8x8.setCursor(11,7);             //// (9,7)
  if (now.hour() < 10)   {u8x8.print("0");} // Ensure value is two digits for formatting purposes.
  u8x8.print(now.hour(), DEC);    
  u8x8.drawString(13,7,":");        //// (11,7,":")
  
  u8x8.setCursor(14,7);               //// (12,7)
  if (now.minute() < 10) {u8x8.print("0");} // Ensure value is two digits for formatting purposes.
  u8x8.print(now.minute(), DEC);
  
//u8x8.drawString(14,7,":");
//u8x8.print(now.second(), DEC);
//u8x8.setCursor(0,8);
//u8x8l.print(daysOfTheWeek[now.dayOfTheWeek()]);  

  delay(6500);                        // 6.5s time to read the small print. 
}
//******************************************************************************   
//******************************************************************************
void fillTc() {  /* Initially fill Tc array with current temperature. */  // "Tc" = temperature in degrees celsius. "arr" = array. 
  delay(750);                           // Initially, do NOT read the sensor too quickly.
  Serial.println("============== INITIAL STATS: TEMP, HUMIDITY, BP ===============");
  float Tc = bme.readTemperature();     // Read the current temperature in degrees Celsius. 
  Serial.print("Tc: ");
  for (int z = 0; z < arrSiz; z++) {    // Populate the array with the current temperature.
    arrTc[z] = Tc;                      // Starting from the right (array index [9]), shift the entire array to the right ONCE.                       
    Serial.print(arrTc[z]);
    Serial.print(" ");             }
  Serial.print("\n");
}
void fillH() {  /* Initially fill H array with current Humidity. */  // "H" = Humidity %. 
  float H = bme.readHumidity();         // Read the current Humidity.
  Serial.print("H:  ");
  for (int y = 0; y < arrSiz; y++) {    // Populate the array with the current temperature.
    arrH[y] = H;                        // Starting from the right (array index [9]), shift the entire array to the right ONCE. 
    Serial.print(arrH[y]);
    Serial.print(" ");             }
  Serial.print("\n");
}
void fillBP() {  /* Initially fill BP array with current barometric pressure. */  // "BP" = Barometric Pressure in kPa. 
  float BP = bme.readPressure();        // Read the current BP.
  Serial.print("BP: ");
  for (int x = 0; x < arrSiz; x++) {    // Populate the array with the current temperature.
    arrBP[x] = (BP / 1000);             // Starting from the right (array index [9]), shift the entire array to the right ONCE. 
    Serial.print(arrBP[x]);
    Serial.print(" ");             }
  Serial.print("\n");
}
//******************************************************************************  
//******************************************************************************   
void outSD(void) {           // Write stats periodically to the microSD card.
  DateTime now = rtc.now();  // Must be in each function's scope.
//Open the file. Note that only one file can be open at a time so you have to close the current one before opening another.
  statsFile = SD.open("THBP.txt", FILE_WRITE);      // SPI. 
  if (statsFile) {                                  // If the file opened okay, write to it and to Serial Monitor.
    Serial.println(F("\n----------- Writing stats to THBP.txt and resetting totalSdMillis counter -----------\n"));
  } else {
    Serial.println(F("\nError opening THBP.txt\n")); // Print an error to the Serial Monitor if the file didn't open.
  }      
  statsFile.print(now.year(),DEC);   // Write date and time to SD: YY/MM/DD HH:MM.
  statsFile.print(F("/"));
  statsFile.print(now.month(),DEC);
  statsFile.print(F("/"));
  statsFile.print(now.day(), DEC); 
  statsFile.print(F(" "));  
  statsFile.print(now.hour(), DEC);  
  statsFile.print(F(":"));    
  statsFile.print(now.minute(), DEC);
  statsFile.print(F(":"));
  statsFile.print(now.second(), DEC); 
  statsFile.print(F("\t\tT:\t"));   // T:xxc xxf
  float Tc = bme.readTemperature(); // Temp in C.
  statsFile.print(Tc,0);            
  statsFile.print(F("c\t")); 
  float Tf = ((Tc * 1.8) + 32);     // Temp in F.
  statsFile.print(Tf,0);
  statsFile.print(F("f"));  
  statsFile.print(F("\t\tH:\t"));   // H:%
  float H = bme.readHumidity();     // Humidity %.
  statsFile.print(H,0);
  statsFile.print(F("%"));  
  statsFile.print("\t\tDP:\t");     // DP:xxc xxf
  float TDPc = ((100 - H) / 5);     // Dew Point temperature in C.
  statsFile.print(TDPc,0);
  statsFile.print(F("c\t"));
  float TDPf = ((TDPc * 1.8) + 32); // Dew Point temperature in F.
  statsFile.print(TDPf,0);
  statsFile.print(F("f"));
  statsFile.print(F("\t\tHX:\t"));  // HX:xxc xxf
  float TDPk = TDPc + 273.15;       // Dew Point temperature in K. 
  float HXc = Tc + (0.5555 * (pow(6.11,(5417.7530 * ((1/273.16) - (1/TDPk))) - 10)));  // Calculate Humidex in C based on Dew Point and Humidity.
  statsFile.print(HXc,0);
  statsFile.print(F("c\t")); 
  float HXf = ((HXc * 1.8) + 32);   // Humidex in F.
  statsFile.print(HXf,0);  
  statsFile.print(F("f")); 
  statsFile.print(F("\t\tBP:\t"));  // HX:xxc xxf
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  statsFile.print(BP,1);
  statsFile.print(F(" kPa\t"));   // kilo Pascals.
  statsFile.print(BPmm,1);
  statsFile.print(F(" mmHg\t"));  // millimeters Mercury.
  statsFile.print(BPin,1);  
  statsFile.println(F(" inHg"));  // inches Mercury.
  statsFile.close();              // Close the file. It will be reopened at the next write interval.    
}
//******************************************************************************
void onLED() {
  digitalWrite(redLED, HIGH);   // turn the LED on (HIGH is the voltage level)   
//digitalWrite(greenLED, HIGH);
//digitalWrite(blueLED, HIGH); 
  }
void offLED() {  
  digitalWrite(redLED, LOW);    // turn the LED off by making the voltage LOW
//digitalWrite(greenLED, LOW);  
//digitalWrite(blueLED, LOW);      
}
void blinkLed() {
  digitalWrite(redLED, HIGH);   // turn the LED on (HIGH is the voltage level)
//digitalWrite(greenLED, HIGH); 
//digitalWrite(blueLED, HIGH); 
  delay(100);
//LowPower.deepSleep(100);      // wait a moment
  digitalWrite(redLED, LOW);    // turn the LED off by making the voltage LOW
//digitalWrite(greenLED, LOW); 
//digitalWrite(blueLED, LOW); 
  delay(100);
//LowPower.deepSleep(100);      // wait a moment
}
//******************************************************************************
void millsTS(void) {   // For TroubleShooting purposes. Keeps track of both SD and OLED times.
  Serial.print(F("currentMillis("));
  Serial.print(currentMillis);
  Serial.print(F(" ms)"));
  Serial.print(F(" - previousMillis("));
  Serial.print(previousMillis);
  Serial.print(F(" ms)"));
  Serial.print(F(" = "));
  Serial.print(currentMillis - previousMillis);
  Serial.print(F(" ms\t")); 
  Serial.print(F("totalOledMillis = "));
  Serial.print(totalOledMillis);
  Serial.print(F(" ms\t"));
  Serial.print(F("totalSdMillis = "));
  Serial.print(totalSdMillis);
  Serial.print(F(" ms\t"));
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  Serial.print(F("BP = "));
  Serial.print(BP,1);
  Serial.print(F(" kPa  "));
  Serial.print(BPmm,1);
  Serial.print(F(" mmHg  "));
  Serial.print(BPin,2);
  Serial.print(F(" inHg\t"));      
  Serial.print(F("pirState = "));
  Serial.println(pirState);
}  
//******************************************************************************+ 
void millsPlot(void) {                // Plot the BP using "Tools|Serial Plotter".
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);        // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);         // Barometric pressure in inches mercury (inHg).
  Serial.print("BP ");
  Serial.println(BP,1);
}  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 void playTone_1() {        // Play a tone/melody.    
  noTone(piezoPin);    
  for (int i = 0; i < numTones; i++) {  
    tone(piezoPin, Tones[i]);
    delay(50);                       }
  noTone(piezoPin);
}
//****************************************************************************** 
/*
void Seg7LedsOn() {                 // Print the current on the quad 7-segment LED module.
  float Tc = bme.readTemperature(); // Temp in C.
  matrix7.print(Tc,1);              // Print the current temperature in C on the quad 7-segment LED module.
  matrix7.writeDisplay();
//++++++++++++++++++++++++++
}
void Seg7LedsOff() {                // Clear display of the quad 7-segment LED module.
  matrix7.clear();
  matrix7.writeDisplay();
}
*/
//******************************************************************************
/* Global variables for the two SD functions that follow:    
 *  unsigned long fileDumpTime = 300000; // Elapsed time since THBP.txt file was dumped to Serial Monitor.
 *  unsigned long fileMillis = 0;        // Track the time between file dumps.
 */
/*
void monFileDump(void) {
  fileMillis = fileMillis + (currentMillis - previousMillis);
  if (fileMillis >= fileDumpTime) {  // 300s
    fileMillis = 0;
    fileDump(); 
  }
}

void fileDump(void) {
  Serial.println("\n");
  Serial.print("DUMP OF THBP.TXT\n");
  Serial.println("================");
  File dataFile = SD.open("THBP.txt");   
  if (dataFile)                       {       // If the file is available, write to it.
    while (dataFile.available())      {
      Serial.write(dataFile.read());  }
    dataFile.close();                 }
  else {
    Serial.println("error opening THBP.txt"); // If the file isn't open, post an error.
  }
}
*/
//******************************************************************************
/* TRENDing Scheme 
 *  Part 1: 
 *  - in global settings, the Tc array (arrTc) was backfilled with a typically lower temperature in degrees C.
 *  - determine the average Tc (avgTc) for the array
 *  - compare the current Tc (arrTc[0]) with the average Tc (avgTc) for the array.
 *  - post whether the temperature is the same, higher or lower than the average by at least +- 0.5 degrees C
 *  Part 2: (INCOMPLETE, AT BOTTOM OF SKETCH)
 *  - store the temp variation deltaTc in the array arrDltaTc
 *  - determine if the current average Tc (avgTc) for this new array exceeds the arrDltaTc average
 *  - post avgDltaTc   ???????????????????????????????????????????????????????????????????
 */ 
 
/* SECONDARY ARRAY FOR LONGER TRENDING
  arrDltaTc[k] = deltaTc;              // Put changes to Tc into another array arrDltaTc.
  sumArrDltaTc =+ arrDltaTc[k];        // sumArrDltaTc = sumArrDltaTc + arrDltaTc[k]

  k++;
  if (k == arrSiz) {  
    k = 0;
    Serial.print("arrDltaTc: ");
    for (int L = arrSiz ; L > 0; L--)  {
      Serial.print(arrDltaTc[k]); 
      Serial.print("\t"); 
      k++;                             }
  }
  avgDltaTc = (sumArrDltaTc / arrSiz); 
  Serial.print("Average DltaTc: "); 
  Serial.println(avgDltaTc);
  if (k == arrSiz)     { 
    (k = 0);
    avgDltaTc = 0;
    sumArrDltaTc = 0; }
 */ 
//******************************************************************************
// humidex = air temperature + (0.5555)*(e - 10.0) where e = 6.11 * exp [5417.7530 * ((1/273.16) - (1/dewpoint in kelvins))]
